# do this in case subincludes define all after including common.mak
all:

ifeq (,$(VERSION))
VERSION:=2.1beta1
VER_TAG:=v$(shell echo $(VERSION) | sed s/\\./_/g)
endif

INSTALL=/usr/bin/install -c -D

prefix=/usr
exec_prefix=/usr
sbindir=/usr/sbin
bindir=/usr/bin
mandir=/usr/share/man
transform=s,^,,

CPPFLAGS:=-I$(TOPDIR)/include
CFLAGS:=-Wall $(CPPFLAGS)
CFLAGS+=-DUSE_L2TP

SYSTEM:=$(shell uname -s)
ARCH:=$(shell uname -m | sed -e s/i[3-6]86/i386/)
TARGET:=$(shell echo "i386-redhat-linux-gnu" | sed -e s/i[3-6]86/i386/)

export VERSION PREFIX SBINDIR BINDIR MANDIR INSTALL

subdirs-all:
	for i in $(SUBDIRS) ; do if [ -e $$i/Makefile.in -a -e $$i/Makefile ] ; then ( cd $$i && $(MAKE) all ) || exit 1 ; fi ; done

subdirs-distclean:
	for i in $(SUBDIRS) ; do if [ -e $$i/Makefile.in -a -e $$i/Makefile ] ; then ( cd $$i && $(MAKE) distclean ) || exit 1 ; fi ; done

subdirs-clean:
	for i in $(SUBDIRS) ; do if [ -e $$i/Makefile.in -a -e $$i/Makefile ] ; then ( cd $$i && $(MAKE) clean ) || exit 1 ; fi ; done

subdirs-install:
	for i in $(SUBDIRS) ; do if [ -e $$i/Makefile.in -a -e $$i/Makefile ] ; then ( cd $$i && $(MAKE) install ) || exit 1 ; fi ; done

install-progs: $(PROGS)
	for i in $(PROGS) ; do ${INSTALL} $$i $(DESTDIR)$(PROGS_BINDIR)/`echo $$i | sed '$(transform)'` ; done

install-manpages: $(MANPAGES)
	for i in $(MANPAGES) ; do ${INSTALL} -m 644 $$i $(DESTDIR)$(mandir)/man`echo $$i | sed -e 's/^.*\\.//'`/`echo $$i | sed '$(transform)'` ; done

